import{s as ge,o as ve}from"../chunks/scheduler.f7e1785c.js";import{S as Te,i as ye,g as r,s,r as B,A as we,h as o,f as a,c as n,j as de,u as K,x as c,k as ee,y as $e,a as i,v as Q,d as X,t as Y,w as Z,m as Ce,n as be}from"../chunks/index.9f8f0838.js";import{T as xe}from"../chunks/Tip.4575d9cf.js";import{H as te}from"../chunks/Heading.6643a2f7.js";function _e(M){let l;return{c(){l=Ce("💡 Even though here we pretend spectrograms are the same as images, there are important differences. For example, shifting the contents of an image up or down generally does not change the meaning of what is in the image. However, shifting a spectrogram up or down will change the frequencies that are in the sound and completely change its character. Images are invariant under translation but spectrograms are not. Treating spectrograms as images can work very well in practice, but keep in mind they are not really the same thing.")},l(f){l=be(f,"💡 Even though here we pretend spectrograms are the same as images, there are important differences. For example, shifting the contents of an image up or down generally does not change the meaning of what is in the image. However, shifting a spectrogram up or down will change the frequencies that are in the sound and completely change its character. Images are invariant under translation but spectrograms are not. Treating spectrograms as images can work very well in practice, but keep in mind they are not really the same thing.")},m(f,u){i(f,l,u)},d(f){f&&a(l)}}}function ke(M){let l,f,u,L,h,P,d,ae="The goal of audio classification is to predict a class label for an audio input. The model can predict a single class label that covers the entire input sequence, or it can predict a label for every audio frame — typically every 20 milliseconds of input audio — in which case the model’s output is a sequence of class label probabilities. An example of the former is detecting what bird is making a particular sound; an example of the latter is speaker diarization, where the model predicts which speaker is speaking at any given moment.",A,g,F,v,ie="One of the easiest ways to perform audio classification is to pretend it’s an image classification problem!",S,T,se='Recall that a spectrogram is a two-dimensional tensor of shape <code>(frequencies, sequence length)</code>. In the <a href="../chapter1/audio_data">chapter on audio data</a> we plotted these spectrograms as images. Guess what? We can literally treat the spectrogram as an image and pass it into a regular CNN classifier model such as ResNet and get very good predictions. Even better, we can use a image transformer model such as ViT.',V,y,ne="This is what <strong>Audio Spectrogram Transformer</strong> does. It uses the ViT or Vision Transformer model, and passes it spectrograms as input instead of regular images. Thanks to the transformer’s self-attention layers, the model is better able to capture global context than a CNN is.",z,w,re="Just like ViT, the AST model splits the audio spectrogram into a sequence of partially overlapping image patches of 16×16 pixels. This sequence of patches is then projected into a sequence of embeddings, and these are given to the transformer encoder as input as usual. AST is an encoder-only transformer model and so the output is a sequence of hidden-states, one for each 16×16 input patch. On top of this is a simple classification layer with sigmoid activation to map the hidden-states to classification probabilities.",I,p,oe='<img src="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/ast.png" alt="The audio spectrogram transformer works on a sequence of patches taken from the spectrogram"/>',E,$,le='Image from the paper <a href="https://arxiv.org/pdf/2104.01778.pdf" rel="nofollow">AST: Audio Spectrogram Transformer</a>',W,m,N,C,j,b,ce='In a <a href="ctc">previous section</a> you’ve seen that CTC is an efficient technique for performing automatic speech recognition using an encoder-only transformer.  Such CTC models already are classifiers, predicting probabilities for class labels from a tokenizer vocabulary. We can take a CTC model and turn it into a general-purpose audio classifier by changing the labels and training it with a regular cross-entropy loss function instead of the special CTC loss.',R,x,fe="For example, HF Transformers has a <code>Wav2Vec2ForCTC</code> model but also <code>Wav2Vec2ForSequenceClassification</code> and <code>Wav2Vec2ForAudioFrameClassification</code>. The only differences between the architectures of these models is the size of the classification layer and the loss function used.",O,_,pe="In fact, any encoder-only audio transformer model can be turned into an audio classifier by adding a classification layer on top of the sequence of hidden states. (Classifiers usually don’t need a transformer decoder.)",D,k,me="To predict a single classification score for the entire sequence (<code>Wav2Vec2ForSequenceClassification</code>), the model takes the mean over the hidden-states and feeds that into the classification layer. The output is a single probability distribution.",G,q,ue="To make a separate classification for each audio frame (<code>Wav2Vec2ForAudioFrameClassification</code>), the classifier is run on the sequence of hidden-states, and so the output of the classifier is a sequence too.",J,H,U;return h=new te({props:{title:"Audio classification architectures",local:"audio-classification-architectures",headingTag:"h1"}}),g=new te({props:{title:"Classification using spectrograms",local:"classification-using-spectrograms",headingTag:"h2"}}),m=new xe({props:{$$slots:{default:[_e]},$$scope:{ctx:M}}}),C=new te({props:{title:"Any transformer can be a classifier",local:"any-transformer-can-be-a-classifier",headingTag:"h2"}}),{c(){l=r("meta"),f=s(),u=r("p"),L=s(),B(h.$$.fragment),P=s(),d=r("p"),d.textContent=ae,A=s(),B(g.$$.fragment),F=s(),v=r("p"),v.textContent=ie,S=s(),T=r("p"),T.innerHTML=se,V=s(),y=r("p"),y.innerHTML=ne,z=s(),w=r("p"),w.textContent=re,I=s(),p=r("div"),p.innerHTML=oe,E=s(),$=r("p"),$.innerHTML=le,W=s(),B(m.$$.fragment),N=s(),B(C.$$.fragment),j=s(),b=r("p"),b.innerHTML=ce,R=s(),x=r("p"),x.innerHTML=fe,O=s(),_=r("p"),_.textContent=pe,D=s(),k=r("p"),k.innerHTML=me,G=s(),q=r("p"),q.innerHTML=ue,J=s(),H=r("p"),this.h()},l(e){const t=we("svelte-u9bgzb",document.head);l=o(t,"META",{name:!0,content:!0}),t.forEach(a),f=n(e),u=o(e,"P",{}),de(u).forEach(a),L=n(e),K(h.$$.fragment,e),P=n(e),d=o(e,"P",{"data-svelte-h":!0}),c(d)!=="svelte-14ita7"&&(d.textContent=ae),A=n(e),K(g.$$.fragment,e),F=n(e),v=o(e,"P",{"data-svelte-h":!0}),c(v)!=="svelte-10zkvxw"&&(v.textContent=ie),S=n(e),T=o(e,"P",{"data-svelte-h":!0}),c(T)!=="svelte-13z3tk6"&&(T.innerHTML=se),V=n(e),y=o(e,"P",{"data-svelte-h":!0}),c(y)!=="svelte-knl08t"&&(y.innerHTML=ne),z=n(e),w=o(e,"P",{"data-svelte-h":!0}),c(w)!=="svelte-1io1u8t"&&(w.textContent=re),I=n(e),p=o(e,"DIV",{class:!0,"data-svelte-h":!0}),c(p)!=="svelte-12cqizh"&&(p.innerHTML=oe),E=n(e),$=o(e,"P",{"data-svelte-h":!0}),c($)!=="svelte-1d94dzw"&&($.innerHTML=le),W=n(e),K(m.$$.fragment,e),N=n(e),K(C.$$.fragment,e),j=n(e),b=o(e,"P",{"data-svelte-h":!0}),c(b)!=="svelte-x063cn"&&(b.innerHTML=ce),R=n(e),x=o(e,"P",{"data-svelte-h":!0}),c(x)!=="svelte-1l2qkhp"&&(x.innerHTML=fe),O=n(e),_=o(e,"P",{"data-svelte-h":!0}),c(_)!=="svelte-1q7ckcr"&&(_.textContent=pe),D=n(e),k=o(e,"P",{"data-svelte-h":!0}),c(k)!=="svelte-k4ynpc"&&(k.innerHTML=me),G=n(e),q=o(e,"P",{"data-svelte-h":!0}),c(q)!=="svelte-1vu9syo"&&(q.innerHTML=ue),J=n(e),H=o(e,"P",{}),de(H).forEach(a),this.h()},h(){ee(l,"name","hf:doc:metadata"),ee(l,"content",qe),ee(p,"class","flex justify-center")},m(e,t){$e(document.head,l),i(e,f,t),i(e,u,t),i(e,L,t),Q(h,e,t),i(e,P,t),i(e,d,t),i(e,A,t),Q(g,e,t),i(e,F,t),i(e,v,t),i(e,S,t),i(e,T,t),i(e,V,t),i(e,y,t),i(e,z,t),i(e,w,t),i(e,I,t),i(e,p,t),i(e,E,t),i(e,$,t),i(e,W,t),Q(m,e,t),i(e,N,t),Q(C,e,t),i(e,j,t),i(e,b,t),i(e,R,t),i(e,x,t),i(e,O,t),i(e,_,t),i(e,D,t),i(e,k,t),i(e,G,t),i(e,q,t),i(e,J,t),i(e,H,t),U=!0},p(e,[t]){const he={};t&2&&(he.$$scope={dirty:t,ctx:e}),m.$set(he)},i(e){U||(X(h.$$.fragment,e),X(g.$$.fragment,e),X(m.$$.fragment,e),X(C.$$.fragment,e),U=!0)},o(e){Y(h.$$.fragment,e),Y(g.$$.fragment,e),Y(m.$$.fragment,e),Y(C.$$.fragment,e),U=!1},d(e){e&&(a(f),a(u),a(L),a(P),a(d),a(A),a(F),a(v),a(S),a(T),a(V),a(y),a(z),a(w),a(I),a(p),a(E),a($),a(W),a(N),a(j),a(b),a(R),a(x),a(O),a(_),a(D),a(k),a(G),a(q),a(J),a(H)),a(l),Z(h,e),Z(g,e),Z(m,e),Z(C,e)}}}const qe='{"title":"Audio classification architectures","local":"audio-classification-architectures","sections":[{"title":"Classification using spectrograms","local":"classification-using-spectrograms","sections":[],"depth":2},{"title":"Any transformer can be a classifier","local":"any-transformer-can-be-a-classifier","sections":[],"depth":2}],"depth":1}';function He(M){return ve(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fe extends Te{constructor(l){super(),ye(this,l,He,ke,ge,{})}}export{Fe as component};
